////////////////////////////////////////////////////////////////////
// QENb^ŋCR͂^V~[V
////////////////////////////////////////////////////////////////////
#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <direct.h>
#include <stdlib.h>
#include "Vector3.h"
#include "RK4.h"

////////////////////////////////////////////////////////////////////
// p[^
////////////////////////////////////////////////////////////////////
//͈̔
double t_min = 0;
double t_max = 5.0;
//t
double dt = 0.01;
//x
double v0 = 20.0;
//ˊpxizj
const int TN = 6;
double thetas[TN] = { 15.0, 30.0, 45.0, 60.0, 75.0, 90.0 };
//d͉x
double g = 10.0;
//
double m = 1.0;
//RW
double beta = 0;
//SRW
double gamma = 1.0;

////////////////////////////////////////////////////////////////////
// _NX
////////////////////////////////////////////////////////////////////
class Particle : public RK4 {
private:
public:
	//
	double m = 1.0;
	//RW
	double beta = 0.0;
	//SRW
	double gamma = 0.0;
	//d͉x
	double g = 0.0;

	//RXgN^
	Particle() {}
	Particle(double _dt) {
		dt = _dt;
	}
	Particle(double _dt, Vector3& _r, Vector3& _v) {
		dt = _dt;
		r.copy(_r);
		v.copy(_v);
	}
	//xxNgiK{j
	Vector3 A(double t, Vector3& r, Vector3& v) {
		Vector3 output;
		output.x = -beta / m * v.length() * v.x - gamma / m * v.x;
		output.y = -beta / m * v.length() * v.y - gamma / m * v.y;
		output.z = -beta / m * v.length() * v.z - gamma / m * v.z - g;
		return output;
	};
};

////////////////////////////////////////////////////////////////////
// C֐
////////////////////////////////////////////////////////////////////
int main(void) {
	//tH_̐
	_mkdir("output");

	//t@C̐ݒ
	std::ostringstream filename;
	filename << "output/ProjectileMotion_AirResistance_RK.txt";
	// t@Co̓Xg[̏
	std::ofstream ofs(filename.str());

	ofs << "#x:x" << std::endl;
	ofs << "#y:z" << std::endl;
	ofs << "#legend: ";
	for (int tn = 0; tn < TN; tn++) {
		ofs << " =" << thetas[tn] << "";
	}
	ofs << std::endl;
	ofs << "#showLines: true true true true true true" << std::endl;
	ofs << "#showMarkers: true true true true true true" << std::endl;
	ofs << "#fills: false false false false false false" << std::endl;
	ofs << "#xrange:" << 0 << " " << 14 << " " << 1 << std::endl;
	ofs << "#yrange:" << 0 << " " << 10 << " " << 1 << std::endl;

	for (int tn = 0; tn < TN; tn++) {
		double theta = thetas[tn] * M_PI / 180.0;
		ofs << "#dataset: " << tn << std::endl;

		//QNb^IuWFNg̐
		Particle particle(dt);
		//ʒuxNgƑxxNg
		particle.r.set(0, 0, 0);
		particle.v.set(v0 * cos(theta), 0, v0 * sin(theta));
		particle.m = m;
		particle.beta = beta;
		particle.gamma = gamma;
		particle.g = g;

		int N = round((t_max - t_min) / dt);
		for (int i = 0; i <= N; i++) {
			double t = i * dt;
			//vZʂ̏o
			//ofs << t << " " << particle.r.x << " " << particle.r.y << " " << particle.r.z << std::endl;
			if(i%2==0)  ofs << particle.r.x << " " << particle.r.z << std::endl;

			//QENb^@ɂ鎞ԔW
			particle.timeEvolution(dt);

			//ʒu̍XV
			particle.r = particle.r + particle.dr;
			//x̍XV
			particle.v = particle.v + particle.dv;
		}
		ofs << std::endl;
	}
	ofs.close();

	return 0;
}

